#!/usr/bin/perl
#cvrtFGH.pl
#Wei Zhu, Iowa State University, 2001.

use Getopt::Std;
my $label="FGH";

my %opts = ();
getopts('s:o:h',\%opts);

if( $opts{h}){
    print "Usage: $0 [-o GIIF-output-file] [-s Seq_Shift] <original-Fgenesh-output-file> \n";
    exit -1;
}


my $outfile = $opts{o} || "-";
my $SeqShift = $opts{s} || 0;
my $infile = $ARGV[0] || "-";
#print "\n $infile $outfile $SeqShift \n";


open FIN,"$infile" or die "Could not open file $infile";
open FOUT,">$outfile" or die "Could not open file $outfile";

$SeqShift-- ;
while( $line = <FIN> ){
	$line = <FIN> until($line =~ /^ Seq name/ || $line eq "");
	last if($line eq "");

	($id) = ($line =~ /^ Seq name: (\S+)/);
	$line = <FIN>;
	($length) = ($line =~ /^ Length of sequence:\s+(\d+)\s/);
#Print title:
	printf FOUT "File=$infile\n";
	printf FOUT "SeqID=$id\n";
	printf FOUT "GenBank=N\n";
	printf FOUT "SeqShift=$SeqShift\n";
	printf FOUT "Length=$length\n";
	printf FOUT "Source=Fgenesh\n";
	printf FOUT "Label=%s\n",$label;
	printf FOUT "SourceID=2\n";
	printf FOUT "HasIntronScore=N\n";
	printf FOUT "HasExonScore=Y\n";
	printf FOUT "\nBEGIN\n";

	$line = <FIN> until($line =~ /^ Positions/);
	$count = 0;
	$line = <FIN>;
	undef(@geneSet);
	undef(@dataSet);
	DONE: while($line !~ /^Predicted/){
#print "$line";
		$count++;
		$line = <FIN> until($line =~ /^ *$count/ || $line =~ /^Predicted/);
#print "$line";
		if($line =~ /^Predicted/){ last DONE; }
		undef(@set);
		$data = "";
		do{
			$data = $data.$line;
			if($line !~ /TSS|PolA/ ){
				$line =~ /^ *$count +(.*)/;
#printf $1."\n";
				@line = split(/ +/,$1);
				$signal = $line[0];
				if($signal eq "+"){
				    push @set, [$line[3]+$SeqShift,$line[5]+$SeqShift,$line[6]];
				}
				else {
				    push @set, [$line[5]+$SeqShift,$line[3]+$SeqShift,$line[6]];
				}
#printf "@line";
			}
			$line = <FIN>;
		}while($line =~ /^ *$count/ );
		if($signal eq "-"){
			@set = reverse(@set);
		}
		push @geneSet, [@set];
		push @dataSet, $data;
	}

	$line = <FIN> until($line =~ /^>/);
	$total = @geneSet;
	for($i=0;$i<$total;$i++){
#Print data:
		$info = $geneSet[$i];
		$num = 0;
		printf FOUT "***%s %3d***\n",$label, $i + 1;
		printf FOUT "  1)Structure:   ( .Begin.  ..End..    Score )\n";
		foreach $exon (@$info){
			$num++;
			($beg,$end,$score) = @$exon;
			&convert();
			printf FOUT "    Exon %3d:      %7d  %7d    %5.3f\n", $num,$beg,$end,$score; 
		}
		printf FOUT "  2)Information:\n";
		@data = split(/\n/,$dataSet[$i]);
		foreach $infoLine (@data){
			printf FOUT "    $infoLine\n";
		}
		do{
			printf FOUT "    $line";
			$line = <FIN>;
		}until(!defined($line) || $line =~ /^>/ || $line eq "");
		last if (!defined($line) || $line eq "");
	}

	printf FOUT "END\n";
	last;
}

sub convert{
	$score = check($score/100.0);
}

sub check{
	my($x) = @_;
	$x = ($x<0)?0:$x;
	$x = ($x>=10)?9.999:$x;
}
