#!/usr/bin/perl -w
#fetch_seq.pl
#Wei Zhu, Iowa State University, 2001.
#... requires bioperl (available from http://bio.perl.org)


use Bio::SeqIO;
use Bio::Seq;
use Bio::Annotation;


@ARGV==5 or die("usage: fetch_seq.pl <IN> <ID> <Start_Pos> <End_Pos> <OUT>\n");

my ($infn,$id,$start_pos,$end_pos,$outfn)=@ARGV;
my $format="GenBank";
 
$in = Bio::SeqIO->new(	-file=> $infn, -format=>$format);

while( my $seqobj = $in->next_seq()){
	if($seqobj->accession_number() eq $id){
		print "$id is found, now getting subsequence ...";
		my $out=Bio::SeqIO->new(-file => ">$outfn", -format => 'Fasta');
		my $subseq=$seqobj->subseq($start_pos,$end_pos);
		my $subSeqObj=Bio::Seq->new(-seq => $subseq,
									-desc => "subsequence of $id from $start_pos to $end_pos",
									-id => $outfn,
									-accession_number=>"temp"
									);
		$out->write_seq($subSeqObj);
		last;
		
	}
	
	
}

print "\nDone.\n";
